CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    

    enablePAL    = false
    audioR       = 10
    audioL       = 11

    x_tiles      = 16
    y_tiles      = 12
    paramcount   = 14   
    display_base = $4400

VAR

  byte  buffer[25]
  word  playRate

  long  scrollSpeed  

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]

OBJ
  Roto  : "WaveZoomer"
  OSC   : "Oscilloscope"
  AY   : "AYcog.spin"
  tv    : "tv"
 
PUB Main | AYregisters, i, j, value
  initTV
  AYregisters := AY.start( audioR, audioL )       'Start the emulated SID in one cog
  OSC.start( display_base, AYregisters + 28, @tv_status, @scrollSpeed )
  Roto.start( display_base, @tv_status )
 
  playRate := 1
 
  byte[AYregisters + 0 ] := 100
  byte[AYregisters + 1 ] := 8
  byte[AYregisters + 2 ] := 128
  byte[AYregisters + 3 ] := 8
  byte[AYregisters + 4 ] := 150
  byte[AYregisters + 5 ] := 8

  byte[AYregisters + 6 ] := 15 ' Noise frequency

  byte[AYregisters + 7 ] := 255 -1-2-4 -8-16-32

  byte[AYregisters + 8] := 15 
  byte[AYregisters + 9] := 15
  byte[AYregisters + 10] := 15

  byte[AYregisters + 11] := 4
  byte[AYregisters + 12] := 1

  'byte[AYregisters + 15] := 0

  repeat
    waitcnt(cnt + 80_000_000/playrate)
'    repeat i from 0 to 15
'      if i == 15
'        byte[AYregisters+i] := (?j)&15
'      else
'        byte[AYregisters+i] := ?j

'    if byte[AYregisters + 15] == 9'+16
'    byte[AYregisters + 0 ] := (i?)&255
'    byte[AYregisters + 15] := 9

PUB initTV | i, dx, dy, color1, color2, color3, color4
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
  repeat i from 0 to 6
    colors[i] := ((4 | (0<<4) | 8)    ) 
    colors[i] |= ((3 | (1<<4) | 8)<<8 )
    colors[i] |= ((6 | (3<<4) | 8)<<16)
    colors[i] |= ((5 | (4<<4) | 8)<<24)
  repeat i from 7 to 10
    color1 := 15-((8+i)&15)
    color2 := 15-((10+i)&15)
    color3 := 14  
    color4 := 1 
    colors[i] := ((3 | (color1<<4) | 8)    ) 
    colors[i] |= ((2 | (color2<<4) | 8)<<8 )
    colors[i] |= ((6 | (color3<<4) | 8)<<16)
    colors[i] |= ((5 | (color4<<4) | 8)<<24)
  repeat i from 11 to 12
    colors[i] := ((4 | (0<<4) | 8)    ) 
    colors[i] |= ((3 | (1<<4) | 8)<<8 )
    colors[i] |= ((5 | (5<<4) | 8)<<16)
    colors[i] |= ((4 | (5<<4) | 8)<<24)

dat
tvparams                long    2               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    enablePAL&1     'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    9+(enablePAL&1)*2'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog